<template>
  <div class="wall_wrapper">

    <transition name="fade">


      <div class="wall" v-if="!user">

        <img 
          v-if="options.header_logo !== false"
          class="application_logo" 
          :class="{'rotating_logo': !options.header_logo}"
          :src="options.header_logo || 'https://cdn.maximemoreillon.com/logo/thick/logo.png'"
          :alt="`${options.title}_logo`"
          >
        <h2>{{options.title}}</h2>

        <LoginForm
          v-if="!loading"
          :options="options"
          @loggedIn="get_current_user()"/>


        <Loader v-if="loading"/>
      </div>


    </transition>

    <slot v-if="!!user && !loading"/>

  </div>
</template>

<script>
// @ is an alias to /src
import LoginForm from './components/LoginForm.vue'
import axios from 'axios'
import VueCookie from 'vue-cookie'
import Loader from '@moreillon/vue_loader'


export default {
  name: 'Home',
  components: {
    LoginForm,
    Loader,
  },
  props: {
    options: Object,
  },
  data(){
    return {
      loading: false,
      user: null,
    }
  },
  mounted(){
    this.get_current_user()
  },
  methods:{

    get_current_user(){


      const jwt = VueCookie.get('jwt')

      this.set_authorization_header(jwt) // Does not feel like the right place to do this

      if(!jwt) return

      this.loading = true

      const url = this.options.identification_url

      const headers = { Authorization: `Bearer ${jwt}` }

      axios.get(url, {headers})
      .then( ({data}) => { this.user = data })
      .catch( (error) => {
        console.error(error)
        VueCookie.delete('jwt')
        if(this.axios) delete this.axios.defaults.headers.common['Authorization']
       })
       .finally( () => {
         this.loading = false
         this.$emit('user', this.user)
       })

    },
    set_authorization_header(jwt) {

      if(!this.axios) return

      // either set or unset the header depending on of jwt being in cookies
      if(jwt) this.axios.defaults.headers.common['Authorization'] = `Bearer ${jwt}`
      else delete this.axios.defaults.headers.common['Authorization']

    },
  }
}
</script>

<style scoped>
.wall {
  position: fixed;
  top: 0;
  left: 0;
  right: 0;
  bottom: 0;
  z-index: 1000;
  background-color: white;

  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: flex-start;

  padding-top: 25vh;

  font-family: sans-serif;
}

.application_logo {
  width: 20vmin;
  width: 20vmin;
  object-fit: contain;
}

.rotating_logo {
  animation-name: rotating_logo;
  animation-duration: 60s;
  animation-timing-function: linear;
  animation-iteration-count: infinite;
}

@keyframes rotating_logo {
  from {
    transform: rotate(0deg);
  }

  to {
    transform: rotate(360deg);
  }
}

.loader {
  font-size: 200%;
}

.fade-enter-active, .fade-leave-active {
  transition: opacity .5s;
}
.fade-enter, .fade-leave-to {
  opacity: 0;
}
</style>
